//: C01:BadException.cpp {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <exception>    // kvli std::bad_exception
#include <iostream>
#include <cstdio>
using namespace std;

// tdy vjimek
class A {};
class B {};

// vlastn funkce terminate()
void my_thandler() {
  cout << "volno terminate()" << endl;
  exit(0);
}

// vlastn sprvci neoekvanch vjimek
void my_uhandler1() { throw A(); }
void my_uhandler2() { throw; }

// Pokud bychom pidali konstrukci throw do f nebo g
// peklada by poznal naruen a ohlsil by chybu.
// Proto ji dme do vlastn funkce
void t() { throw B(); }

void f() throw(A) { t(); }
void g() throw(A, bad_exception) { t(); }

int main() {
  set_terminate(my_thandler);
  set_unexpected(my_uhandler1);
  try {
    f();
  } catch(A&) {
    cout << "zachyceno A z f" << endl;
  }
  set_unexpected(my_uhandler2);
  try {
    g();
  } catch(bad_exception&) {
    cout << "zachyceno bad_exception z g" << endl;
  }
  try {
    f();
  } catch(...) {
    cout << "Tohle se nikdy nevytiskne" << endl;
  }
} ///:~
