//: C01:InitExcept.cpp {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Zpracuje vjimky v podobjektech
#include <iostream>
using namespace std;

class Zakladni {
  int i;
public:
  class ZakladniVyjimka {};
  Zakladni(int i) : i(i) { throw ZakladniVyjimka(); }
};

class Odvozena : public Zakladni {
public:
  class OdvozenaVyjimka {
    const char* msg;
  public:
    OdvozenaVyjimka(const char* msg) : msg(msg) {}
    const char* what() const { return msg; }
  };
  Odvozena(int j) try : Zakladni(j) {
    // tlo konstruktoru
    cout << "toto se nevytiskne" << endl;
  } catch(ZakladniVyjimka&) {
    throw OdvozenaVyjimka("vyvolana podobjektem Zakladni");;
  }
};

int main() {
  try {
    Odvozena d(3);
  } catch(Odvozena::OdvozenaVyjimka& d) {
    cout << d.what() << endl;  // "vyvolana podobjektem Zakladni"
  }
} ///:~
