//: C01:Terminator.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouit funkce set_terminate(). Tak ukazuje nezachycen vjimky.
#include <exception>
#include <iostream>
using namespace std;

void terminator() {
  cout << "J se vrtm!" << endl;
  exit(0);
}

void (*old_terminate)() = set_terminate(terminator);

class Paskvil {
public:
  class Ovoce {};
  void f() {
    cout << "Paskvil::f()" << endl;
    throw Ovoce();
  }
  ~Paskvil() { throw 'c'; }
};

int main() {
  try {
    Paskvil p;
    p.f();
  } catch(...) {
    cout << "uvnit catch(...)" << endl;
  }
} ///:~
