//: C02:Date1.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Prvn verze souboru Datum.h.
#ifndef DATE1_H
#define DATE1_H
#include <string>

class Datum {
public:
  // Stroktura na uchovvn uplynutho asu
  struct Trvani {
    int roky;
    int mesice;
    int dny;
    Trvani(int r, int m, int d)
    : roky(r), mesice(m), dny(d) {}
  };
  Datum();
  Datum(int rok, int mesic, int den);
  Datum(const std::string&);
  int getRok() const;
  int getMesic() const;
  int getDen() const;
  std::string toString() const;
   friend bool operator<(const Datum&, const Datum&);
   friend bool operator>(const Datum&, const Datum&);
   friend bool operator<=(const Datum&, const Datum&);
   friend bool operator>=(const Datum&, const Datum&);
   friend bool operator==(const Datum&, const Datum&);
   friend bool operator!=(const Datum&, const Datum&);
  friend Trvani trvani(const Datum&, const Datum&);
};
#endif // DATE1_H ///:~
