//: C02:HiLo.cpp {RunByHand}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Na ukzku invariantu cyklu hraje hru Vt-men.
#include <cstdlib>
#include <iostream>
#include <string>
using namespace std;

int main() {
  cout << "Mysli si slo od 1 do 100" << endl
        << "Budu hdat; "
        << "ekni mi jestli jsem (N)ad nebo (P)od" << endl;
  int spodni = 1, horni = 100;
  bool uhodnuto = false;
  while(!uhodnuto) {
    // Invariant: the number is in the range [spodni, horni]
    if(spodni > horni) {  // Invariant violation
      cout << "Ty jsi podvdl! Konm" << endl;
      return EXIT_FAILURE;
    }
    int tip = (spodni + horni) / 2;
    cout << "Mj typ je: " << tip << ". ";
    cout << "(N)ad, (P)od nebo (S)prvn? ";
    string odpoved;
    cin >> odpoved;
    switch(toupper(odpoved[0])) {
      case 'N':
        horni = tip - 1;
        break;
      case 'P':
        spodni = tip + 1;
        break;
      case 'S':
        uhodnuto = true;
        break;
      default:
        cout << "Neplatn odpoved" << endl;
        continue;
    }
  }
  cout << "Uhodl jsem!" << endl;
  return EXIT_SUCCESS;
} ///:~
