//: C04:Iofile.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// ten a zpis do jednoho souboru.
#include <fstream>
#include <iostream>
#include "../require.h"
using namespace std;

int main() {
  ifstream in("Iofile.cpp");
  assure(in, "Iofile.cpp");
  ofstream out("Iofile.out");
  assure(out, "Iofile.out");
  out << in.rdbuf(); // Koprovat soubor
  in.close();
  out.close();
  // Otevt pro ten a zpis:
  ifstream in2("Iofile.out", ios::in | ios::out);
  assure(in2, "Iofile.out");
  ostream out2(in2.rdbuf());
  cout << in2.rdbuf();  // Vytisknout cel soubor
  out2 << "Kde to skon?";
  out2.seekp(0, ios::beg);
  out2 << "A co tohle?";
  in2.seekg(0, ios::beg);
  cout << in2.rdbuf();
} ///:~
