//: C04:Istring.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Vstupn etzcov proudy
#include <cassert>
#include <cmath>  // Kvli fabs()
#include <iostream>
#include <limits> // Kvli epsilon()
#include <sstream>
#include <string>
using namespace std;

int main() {
  istringstream s("47 1.414 Toto je test");
  int i;
  double f;
  s >> i >> f; // Vstup oddlen przdnmi znaky
  assert(i == 47);
  double relerr = (fabs(f) - 1.414) / 1.414;
  assert(relerr <= numeric_limits<double>::epsilon());
  string buf2;
  s >> buf2;
  assert(buf2 == "Toto");
  cout << s.rdbuf(); // " je test"
} ///:~
