//: C05:Accumulate.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// pedv "funkci" jako parametr v dob pekladu.
#include <iostream>
using namespace std;

// Hromad vsledky F(0)..F(n)
template<int n, template<int> class F> struct Accumulate {
  enum { val = Accumulate<n-1, F>::val + F<n>::val };
};

// Ukonovac kritrium (vrac hodnotu F(0))
template<template<int> class F> struct Accumulate<0, F> {
  enum { val = F<0>::val };
};

// Rzn "funkce":
template<int n> struct Rovnost {
  enum { val = n };
};

template<int n> struct Ctverec {
  enum { val = n*n };
};

template<int n> struct Krychle {
  enum { val = n*n*n };
};

int main() {
  cout << Accumulate<4, Rovnost>::val << endl; // 10
  cout << Accumulate<4, Ctverec>::val << endl;   // 30
  cout << Accumulate<4, Krychle>::val << endl;     // 100
} ///:~
