//: C05:MedvediKoutek.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ilustruje charakterizan tdy.
#include <iostream>
#include "BearCorner.h"
using namespace std;

// Vlastn tda charakteristiky
class SmiseneCharakteristiky {
public:
  typedef Mleko napoj_t;
  typedef Med svacina_t;
};

// ablona Host (pouv charakteristiky)
template<class Host, class traits = CharakteristikyHosta<Host> >
class MedvediKoutek {
  Host navstevnik;
  typedef typename traits::napoj_t napoj_t;
  typedef typename traits::svacina_t svacina_t;
  napoj_t napoj;
  svacina_t svacina;
public:
  MedvediKoutek(const Host& g) : navstevnik(g) {}
  void pohostit() {
    cout << "Pichz " << navstevnik
         << " podv se " << napoj
         << " a " << svacina << endl;
  }
};

int main() {
  Chlapec cr;
  MedvediKoutek<Chlapec> pc1(cr);
  pc1.pohostit();
  Medvidek pb;
  MedvediKoutek<Medvidek> pc2(pb);
  pc2.pohostit();
  MedvediKoutek<Medvidek, SmiseneCharakteristiky> pc3(pb);
  pc3.pohostit();
} ///:~
