//: C05:BearCorner2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ilustruje postupov tdy.
#include <iostream>
#include "BearCorner.h"
using namespace std;

// Postupov tdy (vyaduj statickou funkci doAction() ):
class Jidlo {
public:
  static const char* doAction() { return "sva"; }
};

class Basta {
public:
  static const char* doAction() { return "cpe do sebe"; }
};

// ablona Host (Pouv charakterizan a postupovou tdu)
template<class Host, class Action,
         class traits = CharakteristikyHosta<Host> >
class MedvediKoutek {
  Host navstevnik;
  typedef typename traits::napoj_t napoj_t;
  typedef typename traits::svacina_t svacina_t;
  napoj_t napoj;
  svacina_t svacina;
public:
  MedvediKoutek(const Host& g) : navstevnik(g) {}
  void pohostit() {
    cout << navstevnik << " " << Action::doAction()
         << " " << napoj
         << " a " << svacina << endl;
  }
};

int main() {
  Chlapec cr;
  MedvediKoutek<Chlapec, Jidlo> pc1(cr);
  pc1.pohostit();
  Medvidek pb;
  MedvediKoutek<Medvidek, Basta> pc2(pb);
  pc2.pohostit();
} ///:~
