//: C05:PocitanaTrida2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// chybn pokus o potn objekt.
#include <iostream>
using namespace std;

class Pocitana {
  static int pocet;
public:
  Pocitana() { ++pocet; }
  Pocitana(const Pocitana&) { ++pocet; }
  ~Pocitana() { --pocet; }
  static int zjistiPocet() { return pocet; }
};

int Pocitana::pocet = 0;

class PocitanaTrida : public Pocitana {};
class PocitanaTrida2 : public Pocitana {};

int main() {
  PocitanaTrida a;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 1
  PocitanaTrida b;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 2
  PocitanaTrida2 c;
  cout << PocitanaTrida2::zjistiPocet() << endl;   // 3 (Error)
} ///:~
