//: C05:CountedClass3.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <iostream>
using namespace std;

template<class T> class Pocitana {
  static int pocet;
public:
  Pocitana() { ++pocet; }
  Pocitana(const Pocitana<T>&) { ++pocet; }
  ~Pocitana() { --pocet; }
  static int zjistiPocet() { return pocet; }
};

template<class T> int Pocitana<T>::pocet = 0;

// zvltn definice tdy
class PocitanaTrida : public Pocitana<PocitanaTrida> {};
class PocitanaTrida2 : public Pocitana<PocitanaTrida2> {};

int main() {
  PocitanaTrida a;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 1
  PocitanaTrida b;
  cout << PocitanaTrida::zjistiPocet() << endl;    // 2
  PocitanaTrida2 c;
  cout << PocitanaTrida2::zjistiPocet() << endl;   // 1 (!)
} ///:~
