//: C06:Counted.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Objekt, kter o sob uchovv zznam
#ifndef COUNTED_H
#define COUNTED_H
#include <vector>
#include <iostream>

class Pocitana {
  static int pocet;
  char* ident;
public:
  Pocitana(char* id) : ident(id) { ++pocet; }
  ~Pocitana() {
    std::cout << ident << " pocet = "
              << --pocet << std::endl;
  }
};

class PocitanyVector : public std::vector<Pocitana*> {
public:
  PocitanyVector(char* id) {
    for(int i = 0; i < 5; i++)
      push_back(new Pocitana(id));
  }
};
#endif // COUNTED_H ///:~
