//: C06:Transform.cpp {-mwcc}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouit STL algoritmu transform().
//{L} Counted
#include <iostream>
#include <vector>
#include <algorithm>
#include "Counted.h"
using namespace std;

template<class T> T* deleteP(T* x) { delete x; return 0; }

template<class T> struct Deleter {
  T* operator()(T* x) { delete x; return 0; }
};

int main() {
  PocitanyVector cv("jedna");
  transform(cv.begin(), cv.end(), cv.begin(),
    deleteP<Pocitana>);
  PocitanyVector cv2("dva");
  transform(cv2.begin(), cv2.end(), cv2.begin(),
    Deleter<Pocitana>());
} ///:~
