//: C07:ListStability.cpp {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Kolem seznam se nic nepesouv.
//{L} Noisy
#include <algorithm>
#include <iostream>
#include <iterator>
#include <list>
#include "Noisy.h"
using namespace std;

int main() {
  list<Noisy> l;
  ostream_iterator<Noisy> out(cout, " ");
  generate_n(back_inserter(l), 25, NoisyGen());
  cout << "\n Tisk seznamu:" << endl;
  copy(l.begin(), l.end(), out);
  cout << "\n Invertovn seznamu:" << endl;
  l.reverse();
  copy(l.begin(), l.end(), out);
  cout << "\n Tdn seznamu list:" << endl;
  l.sort();
  copy(l.begin(), l.end(), out);
  cout << "\n Vmna dvou prvk:" << endl;
  list<Noisy>::iterator it1, it2;
  it1 = it2 = l.begin();
  ++it2;
  swap(*it1, *it2);
  cout << endl;
  copy(l.begin(), l.end(), out);
  cout << "\n Pouit obecn funkce reverse(): " << endl;
  reverse(l.begin(), l.end());
  cout << endl;
  copy(l.begin(), l.end(), out);
  cout << "\n klid" << endl;
} ///:~
