//: C07:VectorInsertAndErase.cpp {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Mazn prvk z vektoru
//{L} Noisy
#include <algorithm>
#include <iostream>
#include <iterator>
#include <vector>
#include "Noisy.h"
using namespace std;

int main() {
  vector<Noisy> v;
  v.reserve(11);
  cout << "Byl rezervovn prostor pro 11 objekt" << endl;
  generate_n(back_inserter(v), 10, NoisyGen());
  ostream_iterator<Noisy> vystup(cout, " ");
  cout << endl;
  copy(v.begin(), v.end(), vystup);
  cout << "vkldn prvku:" << endl;
  vector<Noisy>::iterator it =
    v.begin() + v.size() / 2; // sted
  v.insert(it, Noisy());
  cout << endl;
  copy(v.begin(), v.end(), vystup);
  cout << "\nMazn prvku:" << endl;
  // Nelze pout pedchoz verzi itertoru
  it = v.begin() + v.size() / 2;
  v.erase(it);
  cout << endl;
  copy(v.begin(), v.end(), vystup);
  cout << endl;
} ///:~
