//: C07:WordList2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ukazuje istreambuf_iterator a vkldac itertory.
#include <cstring>
#include <fstream>
#include <iostream>
#include <iterator>
#include <set>
#include <string>
#include "../require.h"
using namespace std;

int main(int argc, char* argv[]) {
  char* fname = "WordList2.cpp";
  if(argc > 1) fname = argv[1];
  ifstream in(fname);
  assure(in, fname);
  istreambuf_iterator<char> p(in), konec;
  set<string> seznamSlov;
  while(p != konec) {
    string slovo;
    insert_iterator<string> ii(slovo, slovo.begin());
    // Najt prvn alfa znak:
    while(p != konec && !isalpha(*p))
      ++p;
    // Koprovat dokud se neobjev znak, kter nen psmeno:
    while(p != konec && isalpha(*p))
      *ii++ = *p++;
    if(slovo.size() != 0)
      seznamSlov.insert(slovo);
  }
  // Vsledky na vstup:
  copy(seznamSlov.begin(), seznamSlov.end(),
    ostream_iterator<string>(cout, "\n"));
} ///:~
