//: C08:CheckedCast2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouv opertor dynamic_cast.
#include <vector>
#include "../purge.h"
#include "Security.h"
using namespace std;

int main() {
  vector<Ceniny*> portfolio;
  portfolio.push_back(new Kov);
  portfolio.push_back(new Investice);
  portfolio.push_back(new Obligace);
  portfolio.push_back(new Akcie);
  for(vector<Ceniny*>::iterator it =
       portfolio.begin();
       it != portfolio.end(); ++it) {
    Investice* cm = dynamic_cast<Investice*>(*it);
    if(cm)
      cm->special();
    else
      cout << "nen Investice" << endl;
  }
  cout << "petypovn z mezilehlho ukazatele:" << endl;
  Ceniny* sp = new Kov;
  Investice* cp = dynamic_cast<Investice*>(sp);
  if(cp) cout << "  je to Investice" << endl;
  Kov* mp = dynamic_cast<Kov*>(sp);
  if(mp) cout << "  je to i Kov!" << endl;
  purge(portfolio);
} ///:~
