//: C01:Unexpected.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// specifikace vjimek a unexpected(),
//{-msc} (neskon sprvn)
#include <exception>
#include <iostream>
using namespace std;

class Nahoru {};
class Vyplnit {};
void g();

void f(int i) throw(Nahoru, Vyplnit) {
  switch(i) {
    case 1: throw Nahoru();
    case 2: throw Vyplnit();
  }
  g();
}

// void g() {}         // Verze 1
void g() { throw 47; } // Verze 2

void my_unexpected() {
  cout << "vyvolna neoekvan vjimka" << endl;
  exit(0);
}

int main() {
  set_unexpected(my_unexpected); // (Ignorujeme nvratovou hodnotu)
  for(int i = 1; i <=3; i++)
    try {
      f(i);
    } catch(Nahoru) {
      cout << "zachyceno Nahoru" << endl;
    } catch(Vyplnit) {
      cout << "zachyceno Vyplnit" << endl;
    }
} ///:~
