//: C01:Wrapped.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// bezpen, zkladn ukazatele.
#include <iostream>
#include <cstddef>
using namespace std;

// Zjednodueno. Vae ablona me mt dal parametry
template<class T, int sz = 1> class PWrap {
  T* ptr;
public:
  class ChybaRozsahu {}; // tda vjimky
  PWrap() {
    ptr = new T[sz];
    cout << "konstruktor PWrap" << endl;
  }
  ~PWrap() {
    delete[] ptr;
    cout << "destruktor PWrap" << endl;
  }
  T& operator[](int i) throw(ChybaRozsahu) {
    if(i >= 0 && i < sz) return ptr[i];
    throw ChybaRozsahu();
  }
};

class Kocka {
public:
  Kocka() { cout << "Kocka()" << endl; }
  ~Kocka() { cout << "~Kocka()" << endl; }
  void g() {}
};

class Pes {
public:
  void* operator new[](size_t) {
    cout << "Vytv se Pes" << endl;
    throw 47;
  }
  void operator delete[](void* p) {
    cout << "Ru se Pes" << endl;
    ::operator delete[](p);
  }
};

class PouzijZdroje {
  PWrap<Kocka, 3> kocky;
  PWrap<Pes> pes;
public:
  PouzijZdroje() { cout << "PouzijZdroje()" << endl; }
  ~PouzijZdroje() { cout << "~PouzijZdroje()" << endl; }
  void f() { kocky[1].g(); }
};

int main() {
  try {
    PouzijZdroje pz;
  } catch(int) {
    cout << "uvnit sprvce" << endl;
  } catch(...) {
    cout << "uvnit catch(...)" << endl;
  }
} ///:~
