//: C03:Replace.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <cassert>
#include <cstddef>  // kvli size_t
#include <string>
using namespace std;

void nahradZnaky(string& zmenMe,
  const string& najdiMe, const string& noveZnaky) {
  // Prohledat zmenMe kvli vyhledvanmu textu,
  // zat od pozice 0:
  size_t i = zmenMe.find(najdiMe, 0);
  // nali jsme etzec, kter se m nahradit?
  if(i != string::npos)
    // Nahradit nalezen text etzcem noveZnaky:
    zmenMe.replace(i, najdiMe.size(), noveZnaky);
}

int main() {
  string velkaNovina = "J myslel, e jsem vidl UFO, kter uneslo Elvise. "
                   "Pli jsem pracoval.";
  string nahrazka("monstrum");
  string najdiMe("UFO");
  // najt "UFO" v etzci velkaNovina a pepsat to:
  nahradZnaky(velkaNovina, najdiMe, nahrazka);
  assert(velkaNovina == "J myslel, e jsem vidl "
										"monstrum, kter uneslo Elvise. Pli jsem pracoval.");
} ///:~
