//: C03:StringReplace.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Jednoduch hledan a nahrazovn v etzci.
#include <cassert>
#include <string>
using namespace std;

int main() {
  string s("Kousek textu");
  string tag("$tag$");
  s.insert(7, tag + ' ');
  assert(s == "Kousek $tag$ textu");
  int start = s.find(tag);
  assert(start == 7);
  assert(tag.size() == 5);
  s.replace(start, tag.size(), "nazdrek");
  assert(s == "Kousek nazdrek textu");
} ///:~
