//: C03:StringSuite.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
//{L} ../TestSuite/Test ../TestSuite/Suite
//{L} TrimTest
// Ukazuje sadu test pro kd ze 3 kapitoly
#include <iostream>
#include "../TestSuite/Suite.h"
#include "StringStorage.h"
#include "Sieve.h"
#include "Find.h"
#include "Rparse.h"
#include "TrimTest.h"
#include "CompStr.h"
using namespace std;
using namespace TestSuite;

int main() {
    Suite suite("Testy etzc");
    suite.addTest(new StringStorageTest);
    suite.addTest(new SieveTest);
    suite.addTest(new FindTest);
    suite.addTest(new RparseTest);
    suite.addTest(new TrimTest);
    suite.addTest(new CompStrTest);
    suite.run();
    long nSelhalo = suite.report();
    suite.free();
    return nSelhalo;
}
/* Vstup:
s1 = 62345
s2 = 12345
Sada "testy etzc"
====================
Test "StringStorageTest":
   Prolo: 2   Neprolo: 0
Test "SieveTest":
   Prolo: 50  Neprolo: 0
Test "FindTest":
   Prolo: 9   Neprolo: 0
Test "RparseTest":
   Prolo: 8   Neprolo: 0
Test "TrimTest":
   Prolo: 11  Neprolo: 0
Test "CompStrTest":
   Prolo: 8   Neprolo: 0
*/ ///:~
