//: C04:Strfile.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Proudov vstup/vstup se sobory;
// Rozdl mezi get() a getline().
#include <fstream>
#include <iostream>
#include "../require.h"
using namespace std;

int main() {
  const int SZ = 100; // velikost bufferu;
  char buf[SZ];
  {
    ifstream in("Strfile.cpp"); // nast
    assure(in, "Strfile.cpp"); // Ovit oteven
    ofstream out("Strfile.out"); // zapsat
    assure(out, "Strfile.out");
    int i = 1; // potadlo dek

    // mn pohodln pstup pro dkov vstup
    while(in.get(buf, SZ)) { // nechat na vstupu \n
      in.get(); // zahodit nsledujc znak (\n)
      cout << buf << endl; // mus se pidat \n
      // Souborov vstup stejn jako standardn vstup/vstup:
      out << i++ << ": " << buf << endl;
    }
  } // destruktor zave in a out

  ifstream in("Strfile.out");
  assure(in, "Strfile.out");
  // Pohodlnj dkov vstup
  while(in.getline(buf, SZ)) { // Odstranit \n
    char* cp = buf;
    while(*cp != ':')
      ++cp;
    cp += 2; // Za ": "
    cout << cp << endl; // I zde se mus pidat \n
  }
} ///:~
