//: C04:StringSeeking.cpp {-bor}{-dmc}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// ten a zpis do etzcovho proudu
#include <cassert>
#include <sstream>
#include <string>

using namespace std;

int main() {
  string text = "Asi nechytme dnou rybiku";
  stringstream ss(text);
  ss.seekp(0, ios::end);
  ss << " a do veera.";
  assert(ss.str() ==
    "Asi nechytme dnou rybiku a do veera.");
  // Zmnit "chytme" na "prodme"
  ss.seekg(6, ios::beg);
  string word;
  ss >> word;
  assert(word == "chytme");
  ss.seekp(6, ios::beg);
  ss << "prodme";
  // Zmnit "rybiku" na "kaiku"
  ss.seekg(21, ios::beg);
  ss >> word;
  assert(word == "rybiku");
  ss.seekp(21, ios::beg);
  ss << "kaiku";
  assert(ss.str() ==
    "Asi neprodme dnou kaiku a do veera.");
  ss.str("K s jinou barvou.");
  assert(ss.str() == "K s jinou barvou.");
} ///:~