//: C05:BearCorner.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#ifndef BEARCORNER_H
#define BEARCORNER_H
#include <iostream>
using std::ostream;

// Tdy poloek (Charakteristiky host):
class Mleko {
public:
  friend ostream& operator<<(ostream& os, const Mleko&) {
    return os << "Mlko";
  }
};

class KondenzovaneMleko {
public:
  friend ostream&
  operator<<(ostream& os, const KondenzovaneMleko &) {
    return os << "Kondenzovan mlko";
  }
};

class Med {
public:
  friend ostream& operator<<(ostream& os, const Med&) {
    return os << "Med";
  }
};

class Kolacky {
public:
  friend ostream& operator<<(ostream& os, const Kolacky&) {
    return os << "Kolky";
  }
};

// Tdy host:
class Medvidek {
public:
  friend ostream& operator<<(ostream& os, const Medvidek&) {
    return os << "Teodor";
  }
};

class Chlapec {
public:
  friend ostream& operator<<(ostream& os, const Chlapec&) {
    return os << "Patrick";
  }
};

// Zkladn ablona charakteristik (przdn - me uchovvat bn typy)
template<class Host> class CharakteristikyHosta;

// Spacializace charakteristik pro typy host
template<> class CharakteristikyHosta<Medvidek> {
public:
  typedef KondenzovaneMleko napoj_t;
  typedef Med svacina_t;
};

template<> class CharakteristikyHosta<Chlapec> {
public:
  typedef Mleko napoj_t;
  typedef Kolacky svacina_t;
};
#endif // BEARCORNER_H ///:~
