//: C05:Conditionals.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouv k vbru kdu podmnky v dob pekladu.
#include <iostream>
using namespace std;

template<bool podminka> struct Vyber {};

template<> class Vyber<true> {
  static void blok1() {
    cout << "Probh blok1\n";
  }
public:
  static void f() { blok1(); }
};

template<> class Vyber<false> {
  static void blok2() {
    cout << "Probh blok2\n";
  }
public:
  static void f() { blok2(); }
};

template<bool podminka> void spustit() {
  Vyber<podminka>::f();
}

int main() {
  spustit<sizeof(int) == 4>();
} ///:~
