//: C05:CountedClass.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// POtn objekt pomoc statickch len.
#include <iostream>
using namespace std;

class PocitanaTrida {
  static int pocet;
public:
  PocitanaTrida() { ++pocet; }
  PocitanaTrida(const PocitanaTrida&) { ++pocet; }
  ~PocitanaTrida() { --pocet; }
  static int zjistiPocet() { return pocet; }
};

int PocitanaTrida::pocet = 0;

int main() {
  PocitanaTrida a;
  cout << PocitanaTrida::zjistiPocet() << endl;   // 1
  PocitanaTrida b;
  cout << PocitanaTrida::zjistiPocet() << endl;   // 2
  { // libovoln rozsah platnosti:
    PocitanaTrida c(b);
    cout << PocitanaTrida::zjistiPocet() << endl; // 3
    a = c;
    cout << PocitanaTrida::zjistiPocet() << endl; // 3
  }
  cout << PocitanaTrida::zjistiPocet() << endl;   // 2
} ///:~
