//: C05:FriendScope.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <iostream>
using namespace std;

class Friendly {
  int i;
public:
  Friendly(int theInt) { i = theInt; }
  friend void f(const Friendly&); // vyaduje globln definici
  void g() { f(*this); }
};

void h() {
  f(Friendly(1));  // Pouv ADL
}

void f(const Friendly& fo) {  // definice sptelen funkce
  cout << fo.i << endl;
}

int main() {
  h(); // Vytiskne 1
  Friendly(2).g(); // Vytiskne 2
} ///:~
