//: C05:PartialOrder2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ukazuje sten uspodn ablon td.
#include <iostream>
using namespace std;

template<class T, class U> class C {
public:
  void f() { cout << "Zkladn ablona\n"; }
};

template<class U> class C<int, U> {
public:
  void f() { cout << "T == int\n"; }
};

template<class T> class C<T, double> {
public:
  void f() { cout << "U == double\n"; }
};

template<class T, class U> class C<T*, U> {
public:
  void f() { cout << "pouito T*\n"; }
};

template<class T, class U> class C<T, U*> {
public:
  void f() { cout << "pouito U*\n"; }
};

template<class T, class U> class C<T*, U*> {
public:
  void f() { cout << "pouito T* a U*\n"; }
};

template<class T> class C<T, T> {
public:
  void f() { cout << "T == U\n"; }
};

int main() {
  C<float, int>().f();    // 1: Zkladn ablona
  C<int, float>().f();    // 2: T == int
  C<float, double>().f(); // 3: U == double
  C<float, float>().f();  // 4: T == U
  C<float*, float>().f(); // 5: pouito T* [T je float]
  C<float, float*>().f(); // 6: pouito U* [U je float]
  C<float*, int*>().f();  // 7: pouito T* a U* [float,int]
  // Nsledujc voln jsou nejednoznan:
//   8: C<int, int>().f();
//   9: C<double, double>().f();
//  10: C<float*, float*>().f();
//  11: C<int, int*>().f();
//  12: C<int*, int*>().f();
} ///:~
