//: C05:StaticAssert2.cpp {-g++}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <iostream>
using namespace std;

// ablona a specializace
template<bool> struct StatickaKontrola {
  StatickaKontrola(...);
};

template<> struct StatickaKontrola<false> {};

// Makro (generuje lokln tdu)
#define STATIC_CHECK(expr, msg) {             \
  class Chyba_##msg {};                       \
  sizeof((StatickaKontrola<expr>(Error_##msg()))); \
}

// Zjitn ztrtovch konverz
template<class Na, class Z> Na safe_cast(Z z) {
  STATIC_CHECK(sizeof(Z) <= sizeof(Na),
               ZtratovaKonverze);
  return reinterpret_cast<Na>(z);
}

int main() {
  void* p = 0;
  int i = safe_cast<int>(p);
  cout << "petypovn na int je OK" << endl;
  //! char c = safe_cast<char>(p);
} ///:~
