//: C05:Urand.h {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Gemertor jednoznanch nhodnch sel.
#ifndef URAND_H
#define URAND_H
#include <bitset>
#include <cstddef>
#include <cstdlib>
#include <ctime>
using std::size_t;
using std::bitset;

template<size_t HorniHranice> class Urand {
  bitset<HorniHranice> pouzite;
public:
  Urand() { srand(time(0)); } // Nahodn slo
  size_t operator()(); // "generator" funkce
};

template<size_t HorniHranice>
inline size_t Urand<HorniHranice>::operator()() {
  if(pouzite.count() == HorniHranice)
    pouzite.reset();  // Zat znovu (vynulovat bitset)
  size_t novaHodnota;
  while(pouzite[novaHodnota = rand() % HorniHranice])
    ; // Dokud nen nalezena jedinn hodnota
  pouzite[novaHodnota] = true;
  return novaHodnota;
}
#endif // URAND_H ///:~
