//: C06:CopyStrings2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Nahrazuje etzce odpovdajc prediktu.
#include <algorithm>
#include <cstddef>
#include <iostream>
#include <string>
using namespace std;

// predikt
bool obsahuje_i(const string& s) {
  return s.find('i') != string::npos;
}

int main() {
  string a[] = {"ti", "m", "rty"};
  const size_t SIZE = sizeof a / sizeof a[0];
  string b[SIZE];
  string* endb = replace_copy_if(a, a + SIZE, b,
    obsahuje_i, string("polib"));
  string* beginb = b;
  while(beginb != endb)
    cout << *beginb++ << endl;
} ///:~
