//: C06:ForEach.cpp {-mwcc}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouit STL algoritmu for_each()
//{L} Counted
#include <algorithm>
#include <iostream>
#include "Counted.h"
using namespace std;

// funktor:
template<class T> class DeleteT {
public:
  void operator()(T* x) { delete x; }
};

// ablona funkce:
template<class T> void smazat(T* x) { delete x; }

int main() {
  PocitanyVector B("dva");
  for_each(B.begin(), B.end(), DeleteT<Pocitana>());
  PocitanyVector C("ti");
  for_each(C.begin(), C.end(), smazat<Pocitana>);
} ///:~
