//: C06:TransformNames.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Dal pouit transform().
#include <algorithm>
#include <cctype>
#include <ctime>
#include <vector>
#include "Inventory.h"
#include "PrintSequence.h"
using namespace std;

struct NovyVylepseny {
  Katalog operator()(const Katalog& kat) {
    return Katalog(toupper(kat.getPolozka()),
      kat.getMnozstvi(), kat.getHodnota());
  }
};

int main() {
  vector<Katalog> vk;
  srand(time(0));  // genertor nhodnhch sel
  generate_n(back_inserter(vk), 15, KatalogGen());
  print(vk.begin(), vk.end(), "vk");
  transform(vk.begin(),vk.end(),vk.begin(),NovyVylepseny());
  print(vk.begin(), vk.end(), "vk");
} ///:~
