//: C07:RawStorageIterator.cpp {-bor}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// demonstruje raw_storage_iterator.
//{L} Noisy
#include <iostream>
#include <iterator>
#include <algorithm>
#include "Noisy.h"
using namespace std;

int main() {
  const int MNOZSTVI = 10;
  // Vytvoit neformtovan loit a petypovat je na poadovan typ:
  Noisy* np = reinterpret_cast<Noisy*>(
    new char[MNOZSTVI * sizeof(Noisy)]);
  raw_storage_iterator<Noisy*, Noisy> rsi(np);
  for(int i = 0; i < MNOZSTVI; i++)
    *rsi++ = Noisy(); // Umstit objekty do loit
  cout << endl;
  copy(np, np + MNOZSTVI,
    ostream_iterator<Noisy>(cout, " "));
  cout << endl;
  // uklidit explicitnm volnm destruktoru:
  for(int j = 0; j < MNOZSTVI; j++)
    (&np[j])->~Noisy();
  // uvolnit neformtovan loit:
  delete reinterpret_cast<char*>(np);
} ///:~
