//: C07:StringVector.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// vektor etzc
#include <fstream>
#include <iostream>
#include <iterator>
#include <sstream>
#include <string>
#include <vector>
#include "../require.h"
using namespace std;

int main(int argc, char* argv[]) {
  const char* fname = "StringVector.cpp";
  if(argc > 1) fname = argv[1];
  ifstream in(fname);
  assure(in, fname);
  vector<string> retezce;
  string radek;
  while(getline(in, radek))
    retezce.push_back(radek);
	// Udlat nco s etzci
  int i = 1;
  vector<string>::iterator w;
  for(w = retezce.begin(); w != retezce.end(); w++) {
    ostringstream ss;
    ss << i++;
    *w = ss.str() + ": " + *w;
  }
  // Nyn je odeslat na vstup:
  copy(retezce.begin(), retezce.end(),
    ostream_iterator<string>(cout, "\n"));
  // jeleiko to nejsou ukazatele, objekty 
	// string se uklid sami!
} ///:~
