//: C07:UniqueList.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Testovn funkce seznamu unique().
#include <iostream>
#include <iterator>
#include <list>
using namespace std;

int a[] = { 1, 3, 1, 4, 1, 5, 1, 6, 1 };
const int ASZ = sizeof a / sizeof *a;

int main() {
  // pro vstup:
  ostream_iterator<int> vystup(cout, " ");
  list<int> li(a, a + ASZ);
  li.unique();
  // Ajajaj! dn duplicita se neodstranila:
  copy(li.begin(), li.end(), vystup);
  cout << endl;
  // Nejprve se mus tdit:
  li.sort();
  copy(li.begin(), li.end(), vystup);
  cout << endl;
  // Nyn m unique() njak efekt:
  li.unique();
  copy(li.begin(), li.end(), vystup);
  cout << endl;
} ///:~
