//: C08:ConstructorOrder.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Poad voln konstruktoru.
#include <iostream>
#include <typeinfo>
using namespace std;

template<int id> class Oznameni {
public:
  Oznameni() {
    cout << typeid(*this).name() << " konstruktor" << endl;
  }
  ~Oznameni() {
    cout << typeid(*this).name() << " destruktor" << endl;
  }
};

class X : public Oznameni<0> {
  Oznameni<1> m1;
  Oznameni<2> m2;
public:
  X() { cout << "X::X()" << endl; }
  ~X() { cout << "X::~X()" << endl; }
};

int main() { X x; } ///:~
