//: C08:RTTIandMultipleInheritance.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <iostream>
#include <typeinfo>
using namespace std;

class BB {
public:
  virtual void f() {}
  virtual ~BB() {}
};

class B1 : virtual public BB {};
class B2 : virtual public BB {};
class MI : public B1, public B2 {};

int main() {
  BB* bbp = new MI; // Petypovn nahoru
  // Uren sprvnho jmna:
  cout << typeid(*bbp).name() << endl;
  // Dynamic_cast funguje sprvn:
  MI* mip = dynamic_cast<MI*>(bbp);
  // Nelze pout petypovn ve starm stylu:
//! MI* mip2 = (MI*)bbp; // Chyba pi pekladu
} ///:~
