//: C09:Paste.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
//{L} Vendor
// Oprava zmatku pomoc VD.
#include <iostream>
#include "Vendor.h"
using namespace std;

class MyBase { // Oprava dodanho rozhran 
public:
  virtual void v() const = 0;
  virtual void f() const = 0;
  // Funkce novho rozhran:
  virtual void g() const = 0;
  virtual ~MyBase() { cout << "~MyBase()" << endl; }
};

class Slepana1 : public MyBase, public Vendor1 {
public:
  void v() const {
    cout << "Slepana1::v()" << endl;
    Vendor1::v();
  }
  void f() const {
    cout << "Slepana1::f()" << endl;
    Vendor1::f();
  }
  void g() const { cout << "Slepana1::g()" << endl; }
  ~Slepana1() { cout << "~Slepana1()" << endl; }
};

int main() {
  Slepana1& p1p = *new Slepana1;
  MyBase& mp = p1p; // Petypovn smrem nahoru
  cout << "voln f()" << endl;
  mp.f();  // Sprvn chovn
  cout << "voln g()" << endl;
  mp.g(); // Nov chovn
  cout << "voln A(p1p)" << endl;
  A(p1p); // Star chovn zstalo
  cout << "voln B(p1p)" << endl;
  B(p1p);  // Star chovn zstalo
  cout << "delete mp" << endl;
  // Smazn odkazu na objekt hromady:
  delete &mp; // Sprvn chovn
} ///:~
