//: C10:PrikazPattern.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#include <iostream>
#include <vector>
using namespace std;

class Prikaz {
public:
  virtual void proved() = 0;
};

class Ahoj : public Prikaz {
public:
  void proved() { cout << "Ahoj "; }
};

class Lidi : public Prikaz {
public:
  void proved() { cout << "Lidi! "; }
};

class JaJsem : public Prikaz {
public:
  void proved() { cout << "J jsem vzor Pkaz!"; }
};

// Objekt uchovvajc pkazy:
class Makro {
  vector<Prikaz*> prikazy;
public:
  void pridat(Prikaz* c) { prikazy.push_back(c); }
  void spustit() {
    vector<Prikaz*>::iterator it = prikazy.begin();
    while(it != prikazy.end())
      (*it++)->proved();
  }
};

int main() {
  Makro makro;
  makro.pridat(new Ahoj);
  makro.pridat(new Lidi);
  makro.pridat(new JaJsem);
  makro.spustit();
} ///:~
