//: C11:DeadlockingDiningPhilosophers.cpp {RunByHand}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Veec filozofov s uvznutm
//{L} ZThread
#include <ctime>
#include "DiningPhilosophers.h"
#include "zthread/ThreadedExecutor.h"
using namespace ZThread;
using namespace std;

int main(int argc, char* argv[]) {
  srand(time(0)); // Inicializovat genertor nhodnch sel
  int premysleni = argc > 1 ? atoi(argv[1]) : 5;
  cout << "Ukonit stiskem <Enter>" << endl;
  enum { SZ = 5 };
  try {
    CountedPtr<Display> d(new Display);
    ThreadedExecutor executor;
    Tycinka c[SZ];
    for(int i = 0; i < SZ; i++) {
      executor.execute(
        new Filozof(c[i], c[(i+1) % SZ], d, i,premysleni));
    }
    cin.get();
    executor.interrupt();
    executor.wait();
  } catch(Synchronization_Exception& e) {
    cerr << e.what() << endl;
  }
} ///:~
